package com.hai.dao;

import com.hai.entity.ApiIpAddress;
import com.hai.entity.ApiIpAddressExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 *
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 *
 **/
@Repository
public interface ApiIpAddressMapper extends ApiIpAddressMapperExt {
    @SelectProvider(type=ApiIpAddressSqlProvider.class, method="countByExample")
    long countByExample(ApiIpAddressExample example);

    @DeleteProvider(type=ApiIpAddressSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiIpAddressExample example);

    @Delete({
            "delete from api_ip_address",
            "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
            "insert into api_ip_address (ip_address, mch_id, ",
            "create_time, update_time, ",
            "ext_1, ext_2, ext_3)",
            "values (#{ipAddress,jdbcType=VARCHAR}, #{mchId,jdbcType=VARCHAR}, ",
            "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
            "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiIpAddress record);

    @InsertProvider(type=ApiIpAddressSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiIpAddress record);

    @SelectProvider(type=ApiIpAddressSqlProvider.class, method="selectByExample")
    @Results({
            @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
            @Result(column="ip_address", property="ipAddress", jdbcType=JdbcType.VARCHAR),
            @Result(column="mch_id", property="mchId", jdbcType=JdbcType.VARCHAR),
            @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
            @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
            @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
            @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
            @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiIpAddress> selectByExample(ApiIpAddressExample example);

    @Select({
            "select",
            "id, ip_address, mch_id, create_time, update_time, ext_1, ext_2, ext_3",
            "from api_ip_address",
            "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
            @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
            @Result(column="ip_address", property="ipAddress", jdbcType=JdbcType.VARCHAR),
            @Result(column="mch_id", property="mchId", jdbcType=JdbcType.VARCHAR),
            @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
            @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
            @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
            @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
            @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    ApiIpAddress selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiIpAddressSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiIpAddress record, @Param("example") ApiIpAddressExample example);

    @UpdateProvider(type=ApiIpAddressSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiIpAddress record, @Param("example") ApiIpAddressExample example);

    @UpdateProvider(type=ApiIpAddressSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiIpAddress record);

    @Update({
            "update api_ip_address",
            "set ip_address = #{ipAddress,jdbcType=VARCHAR},",
            "mch_id = #{mchId,jdbcType=VARCHAR},",
            "create_time = #{createTime,jdbcType=TIMESTAMP},",
            "update_time = #{updateTime,jdbcType=TIMESTAMP},",
            "ext_1 = #{ext1,jdbcType=VARCHAR},",
            "ext_2 = #{ext2,jdbcType=VARCHAR},",
            "ext_3 = #{ext3,jdbcType=VARCHAR}",
            "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiIpAddress record);
}
